;
;application: MARIA VINCIT - revolving tetrahedron (texture + Gouraud )
;             this version: rotary using matrix (thx to Majuma)
;compiler   : FASM 1.65.13
;system     : MenuetOS/KolibriOS
;author     : macgub
;email      : macgub3@wp.pl
;web        : www.macgub.hekko.pl
;Fell free to use this intro in your own distribution of Kolibri/Menuet.
SIZE_X equ 500
SIZE_Y equ 500
TEX_X equ 128	  ; texture width
TEX_Y equ 128	  ;         height
TEX_SHIFT equ 7  ; texture widith shifting
TIMEOUT equ 4
points_count equ 10
triangles_count equ 10

use32

	org    0x0

	db     'MENUET01'	; 8 byte id
	dd     0x01		; header version
	dd     START		; start of code
	dd     I_END		; size of image
	dd     I_END		; memory for app
	dd     I_END		; esp
	dd     0x0 , 0x0	; I_Param , I_Icon

START:	  ; start of execution

     call draw_window
     call convert_tex
     call init_sincos_tab
;     call init_triangles_normals
;     call init_point_normals

still:

    mov  eax,23   ; wait here for event with timeout
    mov  ebx,TIMEOUT
    cmp  [s_flag],0
    je	 @f
    mov  eax,11
  @@:
    int  0x40

    cmp  eax,1	 ; redraw request ?
    je	red
    cmp  eax,2	 ; key in buffer ?
    je	key
    cmp  eax,3	 ; button in buffer ?
    je	button

    jmp  noclose

  red:	  ; redraw
    call draw_window
    jmp  noclose

  key:	  ; key
    mov  eax,2	 ; just read it and ignore
    int  0x40
    jmp  noclose

  button:   ; button
    mov  eax,17   ; get id
    int  0x40

    cmp  ah,1	; button id=1 ?
    je	 @f
    cmp  ah,2
    jne  noclose
    not  [s_flag]
    jmp  noclose
   @@:
    mov  eax,-1   ; close this program
    int  0x40
  noclose:

  mov	 ax,[angle_x]
  inc	 ax
  cmp	 ax,360
  jl	 @f
  xor	 ax,ax
 @@:
  mov	 [angle_x],ax

  mov	 bx,[angle_y]
  add	 bx,2
  cmp	 bx,360
  jl	 @f
  xor	 bx,bx
@@:
  mov	 [angle_y],bx

;  mov    cx,[angle_z]
;  inc    cx
;  cmp    cx,360
;  jl     @f
;  xor    cx,cx
;@@:
;  mov    [angle_z],cx

;  add    [angle_x],1
;  add    [angle_y],3
;  add    [angle_z],1

  mov	 esi,angle_x
  mov	 edi,matrix
  call	 make_rotation_matrix		   ;   esi - offset (pointer) to angles,
					   ;   edi offset to 3x3 matrix
  mov	 esi,points_r
  mov	 edi,rotated_points_r
  mov	 ebx,matrix
  mov	 ecx,4
  call	 rotary

;  mov    esi,point_normals
;  mov    edi,rotated_points_normals
;  mov    ebx,matrix
;  mov    ecx,4
;  call   rotary


  mov	 esi,rotated_points_r
  mov	 edi,translated_points
  mov	 ecx,4
  call	 translate_points

;  call update_colors
;==> call wave_flag
;==> call create_texture  ; 128x128x32 texture
  call fill_Z_buffer
  call clrscr		 ; clear the screen
  call draw_triangles	 ; draw all triangles from the list

  mov eax,7	     ; put image
  mov ebx,screen
  mov ecx,SIZE_X shl 16 + SIZE_Y
  mov edx,5 shl 16 + 20
  int 0x40

  jmp  still

include 'grd_tex.inc'
include 'matrix.inc'

;update_colors:
;  xor   ecx,ecx
;  mov   ebx,colors
; .add:
;  cmp   word[ebx+ecx],20000
;  jnl   @f
;  inc   byte[ebx+ecx]
;  inc   byte[colors+2]
;  inc   byte[colors+4]
; @@:
;  add   ecx,2
;  cmp   ecx,18
;  jnz   .add
;ret

fill_Z_buffer:
	mov	eax,0x70000000
	cld
	mov	edi,Z_buffer
	mov	ecx,SIZE_X*SIZE_Y
	rep	stosd
ret

clrscr:
  mov edi,screen
  mov ecx,SIZE_X*SIZE_Y*3/4
  xor eax,eax
  cld
  rep stosd
ret


draw_triangles:
  mov	  esi,triangles
 again_dts:
  mov	  ebp,translated_points

  movzx   eax,word[esi]
  lea	  eax,[eax*3]
  add	  eax,eax

  mov	  bx,word[ebp+eax]
  mov	  [xx1],bx
  mov	  bx,word[ebp+eax+2]
  mov	  [yy1],bx
  mov	  bx,word[ebp+eax+4]
  mov	  [zz1],bx

  movzx   eax,word[esi+2]
  lea	  eax,[eax*3]
  add	  eax,eax

  mov	  bx,word[ebp+eax]
  mov	  [xx2],bx
  mov	  bx,word[ebp+eax+2]
  mov	  [yy2],bx
  mov	  bx,word[ebp+eax+4]
  mov	  [zz2],bx

  movzx   eax,word[esi+4]
  lea	  eax,[eax*3]
  add	  eax,eax

  mov	  bx,word[ebp+eax]
  mov	  [xx3],bx
  mov	  bx,word[ebp+eax+2]
  mov	  [yy3],bx
  mov	  bx,word[ebp+eax+4]
  mov	  [zz3],bx

  pushad

  push dword 127*65536+1
  push dword 127*65536+127
  push dword 1*65536+68


  mov ax,[xx1]
  shl eax,16
  mov ax,[yy1]
  mov bx,[xx2]
  shl ebx,16
  mov bx,[yy2]
  mov cx,[xx3]
  shl ecx,16
  mov cx,[yy3]

 ; xor   edi,edi

  push	[zz3] ;di  ; z   as word
  movzx  edx,word[esi+4]
  lea	edx,[edx*3]
  add	edx,edx
  push	word[edx+colors]
  push	word[edx+colors+2]
  push	word[edx+colors+4]

  push	[zz2] ;di  ; z coord
  movzx edx,word[esi+2]
  lea	edx,[edx*3]
  add	edx,edx
  push	word[edx+colors]
  push	word[edx+colors+2]
  push	word[edx+colors+4]

  push	[zz1] ;di  ; z
  movzx edx,word[esi]
  lea	edx,[edx*3]
  add	edx,edx
  push	word[edx+colors]
  push	word[edx+colors+2]
  push	word[edx+colors+4]

  mov edx,texture24
  mov esi,Z_buffer
  mov edi,screen

  call tex_plus_grd_triangle

  popad

  add esi,6
  cmp dword[esi],0xffffffff
  jne again_dts

ret



;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************


draw_window:


    mov  eax,12      ; function 12:tell os about windowdraw
    mov  ebx,1	    ; 1, start of draw
    int  0x40

       ; DRAW WINDOW
    mov  eax,0	    ; function 0 : define and draw window
    mov  ebx,100*65536+SIZE_X+20    ; [x start] *65536 + [x size]
    mov  ecx,100*65536+SIZE_Y+30    ; [y start] *65536 + [y size]
    mov  edx,0x02000000     ; color of work area RRGGBB,8->color gl
    mov  esi,0x805080d0     ; color of grab bar  RRGGBB,8->color gl
    mov  edi,0x005080d0     ; color of frames    RRGGBB
    int  0x40

       ; WINDOW LABEL
    mov  eax,4	    ; function 4 : write text to window
    mov  ebx,8*65536+8	   ; [x start] *65536 + [y start]
    mov  ecx,0x20ddeeff     ; font 1 & color ( 0xF0RRGGBB )
    mov  edx,labelt	; pointer to text beginning
    mov  esi,labellen-labelt	; text length
    int  0x40

       ; CLOSE BUTTON
    mov  eax,8	    ; function 8 : define and draw button
    mov  ebx,(SIZE_X+20-19)*65536+12	; [x start] *65536 + [x size]
    mov  ecx,5*65536+12     ; [y start] *65536 + [y size]
    mov  edx,1	    ; button id
    mov  esi,0x6688dd	  ; button color RRGGBB
    int  0x40

      ; speed BUTTON
    mov  eax,8	    ; function 8 : define and draw button
    mov  ebx,(SIZE_X+20-39)*65536+12	; [x start] *65536 + [x size]
    mov  ecx,5*65536+12     ; [y start] *65536 + [y size]
    mov  edx,2	    ; button id
    mov  esi,0x6688dd	  ; button color RRGGBB
    int  0x40

    mov  eax,12      ; function 12:tell os about windowdraw
    mov  ebx,2	    ; 2, end of draw
    int  0x40

    ret

convert_tex:	; 4 bit texture into 24 bit tex
    mov     ecx,tex_end-texture4
    mov     esi,tex_end
    mov     edi,texture24
    cld
 @@:
    lodsb
    movzx   eax,al
    mov     ebx,eax
    and     ax,0x0f
    lea     eax,[eax*3+palette]
    mov     eax,[eax]
    stosd
    dec     edi
    shr     bx,4
    lea     eax,[ebx*3+palette]
    mov     eax,[eax]
    stosd
    dec     edi
    sub     esi,2 ; direction mismatched
    loop    @b
ret

; DATA AREA
s_flag db 0
yo dw 250
xo dw 250
zo dw 150

points_r:
dd -1.0, -1.0, 1.0
dd  1.0, -1.0, 1.0
dd  0.0,  1.0, 0.0
dd  0.0, -1.0,-1.0
dd -1 ;<- end marker

triangles:
dw 0,2,1, 3,2,0, 1,2,3,  0,1,3
dd -1 ;<- end marker

colors:  ;each point own color
;    r      g    b
dw  0x00ff, 0x00ff, 0x00ff
dw  0x0011, 0x0011, 0x00ff
dw  0x0001, 0x00ff, 0x0002
dw  0x00ff, 0x00ff, 0x0011

texture4 file '128X128X4.hex'
tex_end:

palette:
db  65,  68,  71
db  159, 162, 162
db  117, 116, 118
db  206, 210, 210
db  140, 141, 143
db  188, 191, 191
db  96,  94,  97
db  227, 233, 232
db  106, 103, 109
db  171, 173, 175
db  129, 128, 133
db  151, 152, 156
db  198, 201, 204
db  244, 250, 252
db  82,  80,  85
db  218, 223, 223

labelt:
     db   'MARIA VINCIT'
if Ext=MMX
     db   ' (MMX)'
end if
labellen:
i3 dw 3
i180 dw 180
points_count_var dw 4
triangles_count_var dw 4
scale dd 150.0
;light_vector dd 0.0, 1.0, 0.0
;light_colors dw 255, 200,  95
angle_x dw 0
angle_y dw 0
angle_z dw 0

matrix rb 36

xx1 dw ?
yy1 dw ?
zz1 dw ?
xx2 dw ?
yy2 dw ?
zz2 dw ?
xx3 dw ?
yy3 dw ?
zz3 dw ?

cos_tab rd 360
sin_tab rd 360

;vectors rd 30

rotated_points_r rd points_count * 3 + 1

;triangles_normals rd triangles_count * 3

;point_normals rd points_count * 3

;rotated_points_normals rd points_count * 3

translated_points rw points_count * 3 + 2

texture24 rb TEX_X*TEX_Y*3

screen rb SIZE_X * SIZE_Y * 3	; screen buffer

Z_buffer rb SIZE_X * SIZE_Y * 4

memStack rb 2000 ;memory area for stack

I_END:




